<template>
  <v-app :dark="dark">
    <loader :message="loadingMessage" />
    <v-toolbar dark app clipped-left>
      <v-toolbar-title
        class="headline text-uppercase"
        style="cursor:pointer"
        @click="navigateHome"
      >
        <span>2IOA0</span>
        <span class="font-weight-light ml-2">
          <span class="primary--text">DAVIS</span> 420
        </span>
      </v-toolbar-title>
      <v-spacer></v-spacer>
      <v-btn flat fab v-show="dark" @click="toggleDark">
        <v-icon>invert_colors</v-icon>
      </v-btn>
      <v-btn flat fab v-show="!dark" @click="toggleDark">
        <v-icon>invert_colors_off</v-icon>
      </v-btn>
      <v-btn
        flat
        href="https://gitlab.com/luc.geven/dbl-visualization-project"
        target="_blank"
      >
        <span class="mr-2">View Source Code</span>
        <v-icon>code</v-icon>
      </v-btn>
    </v-toolbar>
    <v-content>
      <transition name="fade" mode="out-in">
        <router-view />
      </transition>
    </v-content>
  </v-app>
</template>

<script>
import Loader from "./components/Loader.vue";

import { mapState } from "vuex";
export default {
  name: "App",
  components: {
    Loader
  },
  methods: {
    navigateHome() {
      this.$router.push("/");
    },
    toggleDark() {
      this.$store.commit("toggleDark");
    }
  },
  computed: {
    ...mapState(["dark", "loadingMessage"])
  }
};
</script>

<style>
html {
  overflow-y: auto !important;
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s;
}

.fade-enter,
.fade-leave-active {
  opacity: 0;
}
</style>
